function touchControls:checkButtonPress(x, y)
  if x == nil then x = 0 end
  if y == nil then y = 0 end
  
  -- Reset remote button pressed states
  local button2or6Pressed = false
  local button4or8Pressed = false
  local button3or7Pressed = false
  local button1or5Pressed = false

  -- Handle local button presses
  for _, button in pairs(self.buttons) do
    local distanceToButton = math.sqrt((x - button.x)^2 + (y - button.y)^2)

    if distanceToButton <= self.buttonRadius then
      button.pressed = true
      
      -- Determine which local buttons are pressed
      if button.index == 2 or button.index == 6 then
        button2or6Pressed = true
      elseif button.index == 4 or button.index == 8 then
        button4or8Pressed = true
      elseif button.index == 3 or button.index == 7 then
        button3or7Pressed = true
      elseif button.index == 1 or button.index == 5 then
        button1or5Pressed = true
      end
    end
  end
  
  -- Handle remote button presses
  --self:activateRemoteButtons(button2or6Pressed, button4or8Pressed, button3or7Pressed, button1or5Pressed)
end

function touchControls:activateRemoteButtons(button2or6Pressed, button4or8Pressed, button3or7Pressed, button1or5Pressed)
  -- Set button states based on remote button press
  if remoteButtonPressed then
    for i, button in pairs(self.buttons) do
      if i == 2 and button2or6Pressed then
        button.pressed = true
        print("TEST")
      elseif i == 6 and button2or6Pressed then
        button.pressed = true
      elseif i == 4 and button4or8Pressed then
        button.pressed = true
      elseif i == 8 and button4or8Pressed then
        button.pressed = true
      elseif i == 3 and button3or7Pressed then
        button.pressed = true
      elseif i == 7 and button3or7Pressed then
        button.pressed = true
      elseif i == 1 and button1or5Pressed then
        button.pressed = true
      elseif i == 5 and button1or5Pressed then
        button.pressed = true
      end
    end
  end
end
