-- Update the existing updateThumbstickAxes function to update left thumbstick axes
function touchControls:updateLeftThumbstickAxes(x, y)
  local relativeX = x - self.leftThumbstickX
  local relativeY = y - self.leftThumbstickY
  local length = math.sqrt(relativeX^2 + relativeY^2)

  if length <= self.leftThumbstickRadius then
    -- If the touch position is within the thumbstick radius, directly set the axes
    self.leftxaxis = relativeX / self.leftThumbstickRadius
    self.leftyaxis = relativeY / self.leftThumbstickRadius
  else
    -- If the touch position is outside the thumbstick radius, scale the axes proportionally
    local maxAxisValue = 1
    local scaleFactor = maxAxisValue / (length / self.leftThumbstickRadius) -- Scale factor based on how far the touch is from the center
    self.leftxaxis = relativeX * scaleFactor
    self.leftyaxis = relativeY * scaleFactor
  end
					
					
  
  -- Serialize the thumbstick axis values
  --local serializedData = self.leftxaxis .. "," .. self.leftyaxis

--print(serializedData)
   -- Send the serialized data over the network
  --udp:sendto(serializedData, ip, port)
end

-- Add a new function to update right thumbstick axes
function touchControls:updateRightThumbstickAxes(x, y)
  local relativeX = x - self.rightThumbstickX
  local relativeY = y - self.rightThumbstickY
  local length = math.sqrt(relativeX^2 + relativeY^2)

  if length <= self.rightThumbstickRadius then
    self.rightxaxis = relativeX / self.rightThumbstickRadius
    self.rightyaxis = relativeY / self.rightThumbstickRadius
  else
    local scaleFactor = self.rightThumbstickRadius / length
    self.rightxaxis = relativeX * scaleFactor
    self.rightyaxis = relativeY * scaleFactor
  end
  
  -- Serialize the thumbstick axis values
  local serializedData = self.rightxaxis .. "," .. self.rightyaxis

  -- Send the serialized data over the network
  --udp:sendto(serializedData, ip, port)
end


-- Add functions to update received thumbstick axes
function touchControls:updateReceivedLeftThumbstickAxes(x, y)
  --local relativeX = x - self.receivedLeftXAxis
  local relativeX = 300 - self.receivedLeftXAxis
  local relativeY = y - self.receivedLeftYAxis
  local length = math.sqrt(relativeX^2 + relativeY^2)

  if length <= self.leftThumbstickRadius then
    self.receivedLeftXAxis = relativeX / self.leftThumbstickRadius
    self.receivedLeftYAxis = relativeY / self.leftThumbstickRadius
  else
    local scaleFactor = self.leftThumbstickRadius / length
    self.receivedLeftXAxis = relativeX * scaleFactor
    self.receivedLeftYAxis = relativeY * scaleFactor
  end
end

function touchControls:updateReceivedRightThumbstickAxes(x, y)
  local relativeX = x - self.receivedRightXAxis
  local relativeY = y - self.receivedRightXAxis
  print(relativeX)
  local length = math.sqrt(relativeX^2 + relativeY^2)

  if length <= self.rightThumbstickRadius then
    self.receivedRightXaxis = relativeX / self.rightThumbstickRadius
    self.receivedRightYaxis = relativeY / self.rightThumbstickRadius
  else
    local scaleFactor = self.rightThumbstickRadius / length
    self.receivedRightXaxis = relativeX * scaleFactor
    self.receivedRightYaxis = relativeY * scaleFactor
  end
end
