-- touchControls.lua

touchControls = {
  leftThumbstickRadius = 40,
  rightThumbstickRadius = 40,
  buttonRadius = 25*2,
  buttonDistance = 60,
  leftxaxis = 0,
  leftyaxis = 0,
  rightxaxis = 0,
  rightyaxis = 0,
	
  receivedLeftXAxis = 0,
  receivedLeftYAxis = 0,
  receivedRightXAxis = 0,
  receivedRightYAxis = 0,
  
  leftThumbstickPressed = false,
  rightThumbstickPressed = false,
  buttons = {}
}


touchControls.layout="keyboard"

-- Enum for layout types
local LayoutType = {
	GAMEPAD = 1,
    ARCADE = 2,
    KEYBOARD = 3, -- Add KEYBOARD layout
}

require ("src/Gamepad/createGamepadButtons")
require ("src/Gamepad/createArcadeButtons")
require ("src/Gamepad/removeLeftThumbstickButtons")

require ("src/Gamepad/removeRightThumbstickButtons")
require ("src/Gamepad/toggleLayout")
require ("src/Gamepad/touchEvents")
require ("src/Gamepad/mouseEvents")
require ("src/Menu/checkMenuButtons")
require ("src/Menu/IsHovered")
require ("src/Menu/NetworkSetup")

-- skins

--require ("src/Skins/loadSkins")
--require ("src/Skins/drawTouchControlsSkin")
--loadSkins()


function touchControls:init()
  -- Create left thumbstick
  self.leftThumbstickX = love.graphics.getWidth() / 4
  self.leftThumbstickY = love.graphics.getHeight() / 1.5

  -- Create right thumbstick
  self.rightThumbstickX = love.graphics.getWidth() * 3 / 4
  self.rightThumbstickY = love.graphics.getHeight() / 1.5

-- Create received left thumbstick
  self.receivedLeftXAxis = love.graphics.getWidth() / 4
  self.receivedLeftYAxis = love.graphics.getHeight() / 3

  -- Create received right thumbstick
  self.receivedRightXAxis = love.graphics.getWidth() * 3 / 4
  self.receivedRightYAxis = love.graphics.getHeight() / 3

 -- Create buttons based on layout
  if touchControls.layout == "gamepad" then
    self:createGamepadButtons()
  elseif touchControls.layout == "arcade" then
    self:createArcadeButtons()
  end

end

require ("src/Gamepad/updateThumbstickAxes")
require ("src/Gamepad/checkButtonPress")
require ("src/Gamepad/drawTouchControls")



-- Return touchControls table
return touchControls

